"""
    Gr4vy API

    Welcome to the Gr4vy API reference documentation. Our API is still very much a work in product and subject to change.  # noqa: E501

    The version of the OpenAPI document: 1.1.0-beta
    Contact: code@gr4vy.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from gr4vy.gr4vy_api.openapi_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class CardRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('method',): {
            'CARD': "card",
        },
    }

    validations = {
        ('number',): {
            'max_length': 16,
            'min_length': 14,
            'regex': {
                'pattern': r'^[0-9]{14,16}$',  # noqa: E501
            },
        },
        ('expiration_date',): {
            'max_length': 5,
            'min_length': 5,
            'regex': {
                'pattern': r'^\d{2}\/\d{2}$',  # noqa: E501
            },
        },
        ('security_code',): {
            'max_length': 4,
            'min_length': 3,
            'regex': {
                'pattern': r'^\d{3,4}$',  # noqa: E501
            },
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'method': (str,),  # noqa: E501
            'number': (str,),  # noqa: E501
            'expiration_date': (str,),  # noqa: E501
            'security_code': (str,),  # noqa: E501
            'external_identifier': (str, none_type,),  # noqa: E501
            'buyer_id': (str,),  # noqa: E501
            'buyer_external_identifier': (str,),  # noqa: E501
            'redirect_url': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'method': 'method',  # noqa: E501
        'number': 'number',  # noqa: E501
        'expiration_date': 'expiration_date',  # noqa: E501
        'security_code': 'security_code',  # noqa: E501
        'external_identifier': 'external_identifier',  # noqa: E501
        'buyer_id': 'buyer_id',  # noqa: E501
        'buyer_external_identifier': 'buyer_external_identifier',  # noqa: E501
        'redirect_url': 'redirect_url',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, number, expiration_date, security_code, *args, **kwargs):  # noqa: E501
        """CardRequest - a model defined in OpenAPI

        Args:
            number (str): The 15-16 digit number for this card as it can be found on the front of the card.
            expiration_date (str): The expiration date of the card, formatted `MM/YY`.
            security_code (str): The 3 or 4 digit security code often found on the card. This often referred to as the CVV or CVD.

        Keyword Args:
            method (str): `card`.. defaults to "card", must be one of ["card", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            external_identifier (str, none_type): An external identifier that can be used to match the card against your own records.. [optional]  # noqa: E501
            buyer_id (str): The ID of the buyer to associate this payment method to. If this field is provided then the `buyer_external_identifier` field needs to be unset.. [optional]  # noqa: E501
            buyer_external_identifier (str): The `external_identifier` of the buyer to associate this payment method to. If this field is provided then the `buyer_id` field needs to be unset.. [optional]  # noqa: E501
            redirect_url (str): The redirect URL to redirect a buyer after a 3D Secure flow has been completed. This will be appended with both a transaction ID and status (e.g. `https://example.com/callback? gr4vy_transaction_id=123&gr4vy_transaction_status=capture_succeeded`). This is required if the transaction request body does not include `three_d_secure_data`.. [optional]  # noqa: E501
        """

        method = kwargs.get('method', "card")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.method = method
        self.number = number
        self.expiration_date = expiration_date
        self.security_code = security_code
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
